flash is required to run this application